#!/bin/sh
#Indicate not configured - script waits for it.
rm -f /etc/hcfpcimodem/.serial_configured
sleep 1

#Extract nvm directory into /etc/hcfpcimodem, if not present.
if [ ! -d /etc/hcfpcimodem/nvm ];then
 cd /etc/hcfpcimodem
 if [ -e /tmp/nvm-`uname -r`.tar.gz ];then
  tar -xzf /tmp/nvm-`uname -r`.tar.gz
 elif [ -e /tmp/nvm.tar.gz ];then
  tar -xzf /tmp/nvm.tar.gz
 elif [ -f /tmp/nvm-2.6.30.5.tar.gz ];then
  tar -xzf /tmp/nvm-2.6.30.5.tar.gz
 fi
fi

[ -s /tmp/.modconflicts ] && sed -e 's%^\([a-z0-9_\-]*\)\(.*\)%blacklist \1 # temporarily disabled by hcfpci - conflicts with\2%' /tmp/.modconflicts >> /etc/modprobe.d/blacklist-modem_hcfpcimodem_conflicts.conf

#Start with empty modprobe.conf include file and conflict protection.
echo -n > /etc/modprobe.d/install-modem_hcfpcimodem.conf
#Edit config script to avoid device instances 1-7, avoid setting /dev/modem link, create modprobe.conf include file.
if [ -e /usr/sbin/hcfpciconfig ];then
 if [ "`grep '^#Edited by Puppy Linux' /usr/sbin/hcfpciconfig`" = "" ];then
  echo "/usr/sbin/hcfpciconfig found and being modified."
  sed -i -e 's%^#\!/bin/bash$%#\!/bin/bash\n#Edited by Puppy Linux during extraction of firmware for modem initialization.%' \
   -e 's%while \[ $u -lt 8 \]; do%while [ $u -le 0 ]; do%' \
   -e 's%^[\ \	]*echo \"alias /dev/modem%#echo \"alias /dev/modem%' \
   -e 's%/etc/modprobe\.conf%/etc/modprobe.d/install-modem_hcfpcimodem\.conf%' \
   -e 's%if \[ -d /etc/udev/rules\.d \]; then%if [ -f /etc/udev/rules.d ]; then%' \
   -e 's%ln -sf /dev/ttyS...0 /dev/modem%/bin/true #&%' \
   -e 's%first=240%first=244%' \
   -e 's%max=249%max=251%' \
   -e 's%\tmajor=\${first}%\t[ "${device}" = "ttySDGC" -o  "${device}" = "cuaDGC" ] \\\n\t\t\&\& echo 0 \\\n\t\t\&\& return 0\n\n&%' \
   -e 's%^\t\t\tthen$%&\n\t\t\t\t[ -f /sbin/pup_event_backend_modprobe_protect ] \&\& /sbin/pup_event_backend_modprobe_protect --device_major_number=$major \&\& \\%' \
   -e 's%\tunconfigure_rcscript || exit%#&%' \
   -e 's%\tremove_kernel_modules || exit%#&%' \
   -e 's%rm -f /dev/modem$%/bin/true #&%' \
   -e 's%mv /dev/modem /dev/modem.old$%/bin/true #&%' \
   /usr/sbin/hcfpciconfig
  sync
 fi
 
 #Use edited config script to create devices.
 [ -f /sbin/pup_event_backend_modprobe_protect ] \
  && /sbin/pup_event_backend_modprobe_protect --lock=modulesconf
 /usr/sbin/hcfpciconfig --serial
 [ -f /sbin/pup_event_backend_modprobe_protect ] \
  && /sbin/pup_event_backend_modprobe_protect --unlock=modulesconf
fi

#Append 'include' statement to modprobe.conf
[ -s /etc/modprobe_includes/modem-hcfpcimodem.conf ] && [ "`grep 'install hcfpcihw /bin/true' /etc/modprobe.conf`" = "" ] && echo "include /etc/modprobe_includes/modem-hcfpcimodem.conf" >> /etc/modprobe.conf || rm -f /etc/modprobe_includes/modem-hcfpcimodem.conf
